
{
module PCTokens (Token(..), alexScanTokens) where
}


%wrapper "basic"

$digit = 0-9			-- digits
$alpha = [a-zA-Z]		-- alphabetic characters
$disj = [\|]
$neg  = [\-]
$conj = [\&]

tokens :-

  
  $white+				;
  "--+".*				;
  $disj                                 { \s -> TokDisj}
  $neg                                 	{ \s -> TokNeg}
  $conj					{ \s -> TokConj}
  \(					{ \s -> TokOpen}
  \)					{ \s -> TokClose}
  \=\> 					{ \s -> TokImp}
  \<\=\>				{ \s -> TokEquiv}
  $alpha [$alpha $digit]*		{ \s -> TokVar s }
{
-- Each right-hand side has type :: String -> Token

-- The token type:
data Token =
        TokNeg		|
        TokDisj		|
	TokConj		|
        TokImp		|
  	TokEquiv	|
	TokOpen		|
	TokClose	|
	TokVar String	|
	TokEOF
	deriving (Eq,Show)

}
