module Main
where

import PCFormula
import ToClause
import PCResolution
import List
import Maybe
import Debug.Trace
import System

splitTheorem xs = 
    let 
      (prems,consq) = splitAt i xs
    in (prems, tail(tail consq))
    where i = findSplit xs 0 
          findSplit [] i = i
          findSplit [x] i = i+1
          findSplit (x0:x1:xs) i = if (x0=='|' && x1 == '-')
                           	   then i
                               	   else findSplit (x1:xs) (i+1)

getPrems [] = []
getPrems xs = 
   let 
     (pref,rest) = span (\ x-> x /= ',') xs
   in
    if null rest 
    then [pref]
    else pref:(getPrems (tail rest))


 
stp x = (rmrmfact (concatMap formulaToClause (filter (not.null) (getPrems x))))
stc  = rmrmfact . negateConjecture
sp = search



proofSearch traceon theotxt =
          let 
            (premstxt, consqtxt) = splitTheorem theotxt 
          in 
            let
              axs = trace ("axioms: "++show (getPrems premstxt))
                   (rmrmfact (concatMap formulaToClause 
                                   (filter (not.null) (getPrems premstxt))))
              conj = trace ("conjecture: "++show consqtxt)
                       ((rmrmfact . negateConjecture) consqtxt)
            in (theotxt, bestFirstSearch traceon tightStrategy conj axs)


putResult (th,True) = putStrLn (th++"\nTrue\n")
putResult (th,False) = putStrLn (th++"\nFalse\n")


cleanUp xs = filter (not. (isPrefixOf "--+")) (filter (not . null) xs)
 
main = do args <- getArgs
          traceon <- readIO(args!!0)
          theotxt <- readFile (args!!1)
          mapM   putResult (map (proofSearch traceon) 
                           (cleanUp (lines theotxt)))
          
